﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics;
using Infragistics.Win;
using Infragistics.Win.FormattedLinkLabel;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Documents;
using Infragistics.Documents.PDF;
using Infragistics.Documents.Report;
using Infragistics.Documents.Report.Grid;

namespace WinGridCurrencyMask
{
    public partial class Form1 : Form
    {
        #region Constructor

        public Form1()
        {
            InitializeComponent();
        }

        #endregion

        #region Creating the Products DataTable

        private DataTable CreateProducts()
        {
            DataTable dtData = new DataTable("Products");

            dtData.Columns.Add("ProductID", typeof(int));
            dtData.Columns.Add("ProductName", typeof(String));
            dtData.Columns.Add("SupplierID", typeof(int));
            dtData.Columns.Add("CategoryID", typeof(int));
            dtData.Columns.Add("QuantityPerUnit", typeof(String));
            dtData.Columns.Add("UnitPrice", typeof(Decimal));
            dtData.Columns.Add("UnitsInStock", typeof(short));
            dtData.Columns.Add("UnitsOnOrder", typeof(short));
            dtData.Columns.Add("ReorderLevel", typeof(short));
            dtData.Columns.Add("Discontinued", typeof(Boolean));

            dtData.Rows.Add(new object[] { 1, "Chai", 1, 1, "10 boxes x 20 bags", 18.0, 39, 0, 10, 0 });
            dtData.Rows.Add(new object[] { 2, "Chang", 1, 1, "24 - 12 oz bottles", 19.0, 17, 40, 25, 0 });
            dtData.Rows.Add(new object[] { 3, "Aniseed Syrup", 1, 2, "12 - 550 ml bottles", 10.0, 13, 70, 25, 0 });
            dtData.Rows.Add(new object[] { 4, "Chef Anton's Cajun Seasoning", 2, 2, "48 - 6 oz jars", 22.0, 53, 0, 0, 0 });
            dtData.Rows.Add(new object[] { 5, "Chef Anton's Gumbo Mix", 2, 2, "36 boxes", 21.35, 0, 0, 0, 1 });
            dtData.Rows.Add(new object[] { 6, "Grandmas Boysenberry Spread", 3, 2, "12 - 8 oz jars", 25.0, 120, 0, 25, 0 });
            dtData.Rows.Add(new object[] { 7, "Uncle Bob's Organic Dried Pears", 3, 7, "12 - 1 lb pkgs.", 30.0, 15, 0, 10, 0 });
            dtData.Rows.Add(new object[] { 8, "Northwoods Cranberry Sauce", 3, 2, "12 - 12 oz jars", 40.0, 0, 0, 0, 0 });
            dtData.Rows.Add(new object[] { 9, "Mishi Kobe Niku", 4, 6, "18 - 500 g pkgs.", 97.0, 29, 0, 0, 1 });
            dtData.Rows.Add(new object[] { 10, "Ikura", 4, 8, "12 - 200 ml jars", 31.0, 31, 0, 0, 0 });
            dtData.Rows.Add(new object[] { 11, "Queso Cabrales", 5, 4, "1 kg pkg.", 21.0, 22, 30, 30, 0 });
            dtData.Rows.Add(new object[] { 12, "Queso Manchego La Pastora", 5, 4, "10 - 500 g pkgs.", 38.0, 86, 0, 0, 0 });
            dtData.Rows.Add(new object[] { 13, "Konbu", 6, 8, "2 kg box", 6.0, 24, 0, 5, 0 });
            dtData.Rows.Add(new object[] { 14, "Tofu", 6, 7, "40 - 100 g pkgs.", 23.25, 35, 0, 0, 0 });
            dtData.Rows.Add(new object[] { 15, "Green Shouyu", 6, 2, "24 - 250 ml bottles", 15.50, 39, 0, 5, 0 });
            dtData.Rows.Add(new object[] { 16, "Pavlova", 7, 3, "32 - 500 g boxes", 17.45, 29, 0, 10, 0 });
            dtData.Rows.Add(new object[] { 17, "Alice Mutton", 7, 6, "20 - 1 kg tins", 39.00, 39, 0, 0, 1 });
            dtData.Rows.Add(new object[] { 18, "Carnarvon Tigers", 7, 8, "16 kg pkg", 62.50, 42, 0, 0, 0 });
            dtData.Rows.Add(new object[] { 19, "Teatime Chocolate Biscuits", 8, 3, "10 boxes x 12 pieces", 9.20, 25, 0, 5, 0 });
            dtData.Rows.Add(new object[] { 20, "Sir Rodney's Marmalade", 8, 3, "30 gift boxes", 81.00, 40, 0, 0, 0 });

            dtData.AcceptChanges();
            return dtData;
        }
    

        #endregion

        #region Form1_Load

        private void Form1_Load(object sender, EventArgs e)
        {
            this.bindingSource1.DataSource = CreateProducts().DefaultView;
            this.ultraGrid1.DataSource = this.bindingSource1;
            this.ultraGrid1.Focus();

        }

        #endregion

        #region ultraGrid1_InitializeLayout

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            e.Layout.Bands[0].Columns["UnitPrice"].Format = "c";
            e.Layout.Bands[0].Columns["UnitPrice"].MaskInput = "99.##";
            e.Layout.Override.AllowUpdate = DefaultableBoolean.True;
            e.Layout.Override.AllowAddNew = AllowAddNew.No;
            e.Layout.AddNewBox.Hidden = true;
            e.Layout.Override.CellClickAction = CellClickAction.Default;

            e.Layout.Bands[0].Columns["UnitPrice"].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.URL;
            e.Layout.Bands[0].Columns["ProductName"].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.URL;
            e.Layout.Bands[0].Columns["ProductID"].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.URL;

            e.Layout.Bands[0].Columns.Add("Text", "Text");
            e.Layout.Bands[0].Columns["Text"].Header.VisiblePosition = 0;
            e.Layout.Bands[0].Columns["Text"].DataType = typeof(string);
            //e.Layout.Bands[0].Columns["Text"].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.FormattedTextEditor;
            e.Layout.Bands[0].Columns["Text"].CellMultiLine = DefaultableBoolean.True;
            //e.Layout.Bands[0].Columns["Text"].VertScrollBar = true;
            e.Layout.Bands[0].Columns["Text"].AutoSizeEdit = DefaultableBoolean.True;
            //FormattedLinkEditor textEditor = new FormattedLinkEditor(true);
            //textEditor.ScrollBarDisplayStyle = Infragistics.Win.UltraWinScrollBar.ScrollBarDisplayStyle.Automatic;
            //e.Layout.Bands[0].Columns["Text"].Editor = textEditor;
            
            e.Layout.Bands[0].Columns.Add("Date", "Date");
            e.Layout.Bands[0].Columns["Date"].Header.VisiblePosition = 1;
            e.Layout.Bands[0].Columns["Date"].DataType = typeof(DateTime);
            e.Layout.Bands[0].Columns["Date"].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.URL;

            e.Layout.Bands[0].Summaries.Add("UnitsInStockSummary", SummaryType.Sum, e.Layout.Bands[0].Columns["UnitsInStock"]);
            e.Layout.Override.RowSizing = RowSizing.AutoFree;

            //e.Layout.Override.CellDisplayStyle = CellDisplayStyle.FormattedText;
        }

        #endregion

        #region ultraGrid1_Enter

        private void ultraGrid1_Enter(object sender, EventArgs e)
        {
            //EmbeddableEditorBase editor;

            //for (int i = 0; i < ultraGrid1.Rows.Count; i++ )
            //{
            //    if(ultraGrid1.Rows[i].Cells["UnitPrice"].Activation == Activation.AllowEdit)
            //    {
            //        ultraGrid1.Rows[i].Cells["UnitPrice"].Activate();
            //        editor = ultraGrid1.Rows[i].Cells["UnitPrice"].EditorResolved;
            //        ultraGrid1.PerformAction(UltraGridAction.EnterEditMode);
            //        editor.Focus();
            //        break;
            //    }
            //}
        }

        #endregion

        #region ultraGrid1_InitializeRow

        private void ultraGrid1_InitializeRow(object sender, InitializeRowEventArgs e)
        {
            e.Row.Cells["Date"].Value = DateTime.Today;
            if(!e.ReInitialize)
            {
                e.Row.Cells["Text"].Value = "Lots of text to fill up the space to make it wrap. We gotta make this big.";
            }
        }

        #endregion

        #region ultraButton1_Click

        private void ultraButton1_Click(object sender, EventArgs e)
        {
            //this.ultraGrid1.DisplayLayout.Bands[0].SummaryFooterCaption = "New Summary Footer Catpion";
            this.ultraGridDocumentExporter1.Export(this.ultraGrid1, Path.Combine(Application.StartupPath, @"..\..\Reports\Report.PDF"), Infragistics.Win.UltraWinGrid.DocumentExport.GridExportFileFormat.PDF);
        }

        #endregion

        #region ultraGridDocumentExporter1_SummaryCellExporting

        private void ultraGridDocumentExporter1_SummaryCellExporting(object sender, Infragistics.Win.UltraWinGrid.DocumentExport.SummaryCellExportingEventArgs e)
        {
            //IGridCell cell = e.ReportCell;
            //cell.AddQuickText("This is quick text");
            //e.Cancel = true;
        }

        #endregion

        #region ultraGridDocumentExporter1_SummaryRowExporting

        private void ultraGridDocumentExporter1_SummaryRowExporting(object sender, Infragistics.Win.UltraWinGrid.DocumentExport.SummaryRowExportingEventArgs e)
        {
            e.GridSummaryRow.Band.SummaryFooterCaption = "New Summary Footer Caption";
        }

        #endregion

        #region ultraGrid1_AfterExitEditMode

        private void ultraGrid1_AfterExitEditMode(object sender, EventArgs e)
        {
            if (this.ultraGrid1.ActiveCell.Column.Key == "Text")
            {
                this.ultraGrid1.ActiveCell.Row.PerformAutoSize();
            }
        }

        #endregion

        #region ultraGrid1_CellChange

        private void ultraGrid1_CellChange(object sender, CellEventArgs e)
        {
            
        }

        #endregion
    }
}
